`timescale 1ns / 1ps

module fsm(
    output reg enable1,
    output reg enable2,
    input clk,
    input rst_n,
    input next
    );
    reg [1:0] state;
    reg [1:0] next_state;
    
    always@*
        case(state)
            2'b00:
              if(next)
                begin
                next_state = 2'b01;
                enable1 = 0;
                enable2 = 0;
                end
              else
                begin
                next_state = 2'b00;
                enable1 = 0;
                enable2 = 1;
                end
            2'b01:
              if(next)
                begin
                next_state = 2'b10;
                enable1 = 1;
                enable2 = 0;
                end
              else
                begin
                next_state = 2'b01;
                enable1 = 0;
                enable2 = 0;
                end
            2'b10:
              if(next)
                begin
                next_state = 2'b11;
                enable1 = 0;
                enable2 = 0;
                end
              else
                begin
                next_state = 2'b10;
                enable1 = 1;
                enable2 = 0;
                end
            2'b11:
              if(next)
                begin
                next_state = 2'b00;
                enable1 = 0;
                enable2 = 1;
                end
              else
                begin
                next_state = 2'b11;
                enable1 = 0;
                enable2 = 0;
                end
            default:
                begin
                next_state = 2'b00;
                enable1 = 0;
                enable2 = 1;
                end
            endcase
            
    always@(posedge clk or negedge rst_n)
        if(~rst_n) state <= 2'b00;
        else state <= next_state;
        
endmodule
