`timescale 1ns / 1ps

module lab8_2(
    output [7:0] ssd,
    output [3:0] yes,
    inout wire PS2_DATA,
	inout wire PS2_CLK,
    input wire rst_n,
	input wire clk
    );
    wire [1:0] ctl; wire [3:0] ssd_in;
    wire [511:0] key_down; wire [8:0] last_change; wire key_valid;
    wire [3:0] num; reg [3:0] num_save, num1, num2; reg [4:0] sum;
    reg [3:0] q1, q0;
    wire enable1, enable2;
    always@*
	   if(key_valid) num_save = num;
	   else num_save = num_save;
	always@*
	   if(enable1 && key_valid) 
	       begin
	       num1 = num_save;
	       num2 = 4'd0;
	       end
	   else if(enable2 && key_valid)
	       begin
	       num1 = num1;
	       num2 = num_save;
	       end
	   else 
	       begin
	       num1 = num1;
	       num2 = num2;
	       end
	always@*
	   begin
	   sum = num1 + num2;
	   q1 = sum / 4'd10;
	   q0 = sum % 4'd10;
	   end
    KeyboardDecoder U_keyboard(
	  .key_down(key_down),
	  .last_change(last_change),
	  .key_valid(key_valid),
	  .PS2_DATA(PS2_DATA),
	  .PS2_CLK(PS2_CLK),
	  .rst(~rst_n),
	  .clk(clk)
    );
    fsm U_fsm(
      .enable1(enable1),
      .enable2(enable2),
      .clk(clk),
      .rst_n(rst_n),
      .next(key_valid)
    );
    change U_change(
      .num(num),
      .last_change(last_change)
    );
    freqdiv_ctl2 U_1HZ(
      .ctl(ctl),
      .clk(clk),
      .rst_n(rst_n)
    );
    scan_ctl U_SC(
     .ssd_ctl(yes),
     .ssd_in(ssd_in),
     .in0(num1),
     .in1(num2),
     .in2(q1),
     .in3(q0),
     .ssd_ctl_en(ctl) 
    );
    display_n U_D(
     .i(ssd_in),
     .SSD(ssd)
    );
endmodule
